c23456789012345678901234567890123456789012345678901234567890123456789012
       PROGRAM NUSSELT1
       IMPLICIT DOUBLE PRECISION (A-H,O-Z)
       PARAMETER (NPMAX=5000,NMAX=50,NXMAX=500,NMAXEIG=400)
        COMMON /DADOS/ NEIGEN,EV(NMAXEIG),UNU,APTT,K,NFLOW
	   REAL*8 rr(NPMAX+1),yfinal(NPMAX+1,NMAX),r(NPMAX+1)
c	   REAL*8 yprime(NPMAX+1,NMAX),ywallpr(NMAX,NMAXEIG)
	   REAL*8 y2(NMAXEIG,NPMAX+1),y22(NMAXEIG,NPMAX+1)
	   REAL*8 ywall(NMAX,NMAXEIG),THETAM(NPMAX+1)
	   REAL*8 ANUSSEL(NPMAX+1),x(NXMAX),xprime(NXMAX)
	   REAL*8 TETA(NPMAX+1,NXMAX),SUMTET(NPMAX+1)
	   REAL*8 UNU,APTT,AINTEGR(NMAXEIG),h,BR(40),DELTAX
	   REAL*8 AUX1,AUX2,ANUM1,ADEN1,SUMNUM,SUMDEN,AUX3(NPMAX+1)
	   REAL*8 AUX4(NXMAX),AUX5,AUX6,AUX7,AUX8(NPMAX+1)
	   INTEGER npoints,nfun,NEIGEN,IFLAG(NMAXEIG),NFLOW,NBR,IBOUND
	   INTEGER NXS
           CHARACTER*50 TITLE,TITLE2			!I added for comments
c   This code reads the output of previous programs sledge and rungekutta3.5.f 
c   and calculates the Nusselt number and the temperature profile

c    6th July 2001

c   Input of data from previous data files
       OPEN(7,FILE='rungein.dat')
       REWIND 7
       READ(7,*) TITLE2
       READ(7,*) nfun			!number of functions
       READ(7,*) h,ndata		!step size, number of radial points used for all calculations
       CLOSE(7)

       OPEN(10,FILE='sledout.dat',STATUS='OLD')
       REWIND 10
        READ(10,*)TITLE		!any comment
	READ(10,*)NFLOW,UNU,APTT,NEIGEN,IBOUND	!reads n, UN/U, a, number of eigen functions

       DO 30 I = 1,NEIGEN
         READ (10,12) Ilixo,EV(I),IFLAG(I)
   30  CONTINUE
   12    FORMAT(I6,2X,D25.15,2X,I3)				!Format for printout in file
   
       CLOSE(10)

        OPEN(15,FILE='brinkx.dat',STATUS='OLD')
	REWIND 15
	READ(15,*)NBR					!number of Brinkman numbers
	DO I=1,NBR
	   READ(15,*) BR(I)
	END DO
	READ(15,*)NXS,DELTAX
	READ(15,*)npoints			!number of radial points we wish to calculate and output.
c    ndata must be a multiple of npoints otherwise there will be problems.
	CLOSE(15)
	
        IF (DELTAX .GT. 0.0) THEN
c   Define the coordinates x (axial coordinates). Linear variation
         xprime(1)=0.0			!this is x'
         x(1)=0.0			!this is x*
	 DO I=2,NXS
	   xprime(I)=xprime(I-1)+DELTAX			!This is x'.It must be converted into x*
	   x(I)=xprime(I)*4.*(2.-NFLOW)*(2.-NFLOW)	!Converting x' (variable xprime) into x* (variable x)
	 END DO
c   End of coordinate x generation if linear

        ELSE IF (DELTAX .LT. 0.0) THEN	!This part is wrong
c   Define the coordinates x (axial coordinates). logarithmic variation
         xprime(1)=1.0D-06			!this is x'
         x(1)=xprime(1)*4.*(2.-NFLOW)*(2.-NFLOW)			!this is x*
	 DO I=2,NXS
	   AI=I
	   AB=DMOD(AI,1.0D+01)
	   AA=DINT(AI/1.0D+01)
	   AC=DLOG10(AA+AB)
	   IF (AA+AB .GT. 10) THEN
	     AD=DMOD(AA+AB,1.0D+01)
	     AC=DLOG10(AD+(1.0D+00))
	     AA=AA+1.0D+00
	   END IF
	   xprime(I)=xprime(1)*(1.0D+01)**(AC+AA)			!This is x'.It must be converted into x*
	   x(I)=xprime(I)*4.*(2.-NFLOW)*(2.-NFLOW)	!Converting x' (variable xprime) into x* (variable x)
	 END DO
c   End of coordinate x generation if logarithmic
        ENDIF

        OPEN(22,FILE='rungeoutput.dat',STATUS='OLD')		!formatted for further use by nusselt.f
	REWIND 22
	READ(22,*)TITLE2
	
        DO 20 K=1,NEIGEN
          READ(22,*)Ilixo,EV(k)					!formatted for further use
	     DO J=1,nfun
              IF (J .EQ. 2) THEN				!formmated for further use
                DO I=0,ndata					!formmated for further use
                  READ(22,50)II,rr(I+1),yfinal(I+1,J)		 	!formmated for further use	   
                  y22(k,I+1)=yfinal(I+1,J)
                END DO	   					!formmated for further use
              ENDIF						!formmated for further use
          I=npoints
c              READ(22,50)II,rr(I+1),yfinal(I+1,J),yprime(I+1,J) 	!formatted for further use   
              READ(22,50)II,rr(I+1),yfinal(I+1,J) 		!formatted for further use   
              ywall(J,k)=yfinal(I+1,J)				!functions yis at wall for each eigenvalue
c	      ywallpr(J,k)=yprime(I+1,J)				!derivatives yis at wall for each eigenvalue
	     END DO
	  READ(22,*) AINTEGR(k)
 20     CONTINUE

	CLOSE(22)

c   End of data input

c   Now preparing function y2 to include only the data at npoints
        ifactor=ndata/npoints
        DO K=1,NEIGEN
	 DO I=0,npoints
	  II=ifactor*I
	  y2(k,I+1)=y22(k,II+1)
	  r(I+1)=rr(II+1)
	 END DO
	END DO

c   End

c   Just opening the files for output (to open only once)

        OPEN(16,FILE='nusselt.dat')
	REWIND 16
	WRITE(16,*)'APTT = ',APTT,'NFLOW= ',NFLOW

	OPEN(17,FILE='tempera.dat')
	REWIND 17
	WRITE(17,*)'APTT = ',APTT,'NFLOW= ',NFLOW

c   Now, let's start the calculations (Do one calculation for each Brinkman number)
        AUX1=24.*(54.*APTT*APTT+110.*APTT+55.)/1925.*(1.-NFLOW)
	AUX2=(280.*APTT*APTT+504.*APTT+225.)*NFLOW/270.
        DO 130 IBR=1,NBR
	IF (IBOUND .EQ. 1) THEN				!IBOUND=1 is Twall constant
	   AUX5=(2.**(2.+NFLOW)*6.*APTT+(5.+4.*NFLOW)*4.)*3./(20.+
     *       7.*NFLOW)*BR(IBR)*UNU*UNU				!for THETAM
	   ANUM1=-(3.+NFLOW)*BR(IBR)*UNU		!For Nu
	   ADEN1=-(AUX1+AUX2)*BR(IBR)*UNU*UNU*UNU	!For Nu
	   
	   DO 45 II=1,npoints+1							!For temperature
           AUX3(II)=1.-(2.**(2.+NFLOW)*APTT*(r(II)**6-1.)+(5.+4.*NFLOW)*	!For temperature
     *       (r(II)**4-1.))*3./(20.+7.*NFLOW)*BR(IBR)*UNU*UNU			!For temperature				
 45        CONTINUE								!For temperature
 
           DO 40 I=1,NXS
	     SUMNUM=0.			!for the Nusselt number
	     SUMDEN=0.			!for the Nusselt number  
             DO II=1,npoints+1
	       SUMTET(II)=0.		!for temperature
	     END DO
	     DO 35 k=1,NEIGEN
	       SUMNUM=SUMNUM+EXP(-EV(k)*EV(k)*x(I))/EV(k)/ywall(4,k)*			!For Nusselt
     *          (ywall(1,k)-(3.+NFLOW)*(3.+NFLOW)*BR(IBR)*AINTEGR(k))			!For Nusselt
               SUMDEN=SUMDEN+EXP(-EV(k)*EV(k)*x(I))/EV(k)**3/ywall(4,k)*		!For Nusselt
     *          (NFLOW+1.)*(ywall(1,k)-(3.+NFLOW)*(3.+NFLOW)*BR(IBR)*			!For Nusselt
     *          AINTEGR(k))								!For Nusselt
               DO II=1,npoints+1		!For temperature
	         SUMTET(II)=SUMTET(II)+EXP(-EV(k)*EV(k)*x(I))/EV(k)/
     *            ywall(4,k)/ywall(1,k)*y2(k,II)*(ywall(1,k)-(3.+NFLOW)*	!For temperature
     *            (3.+NFLOW)*BR(IBR)*AINTEGR(k))				!For temperature						
               END DO
 35          CONTINUE
            ANUSSEL(I)=(ANUM1+2.*SUMNUM)/(ADEN1+2.*SUMDEN)*2.*(2.-NFLOW)
            THETAM(I)=(-AUX5+2.*SUMNUM)/ANUSSEL(I)*2.*(2.-NFLOW)
              DO II=1,npoints+1
                TETA(II,I)=AUX3(II)+2.*SUMTET(II)
	      END DO
 40        CONTINUE	

	ELSE IF (IBOUND .EQ. 0) THEN		!IBOUND=0 is wall heat flux constant

          n=1-NFLOW
	  AUX1=UNU*UNU*(NFLOW*(19./54.*APTT*APTT+17./30.*APTT+11./48.)+			!For Nusselt
     *      n*(303./1925.*APTT*APTT+29./105.*APTT+17./140.))				!For Nusselt
          AUX2=BR(IBR)*UNU*UNU*UNU*(NFLOW/UNU/UNU+n*(468./385.*APTT*			!For Nusselt
     *      APTT+68./35.*APTT+27./35.))							!For Nusselt
          AUX5=NFLOW/2160.*(760.*APTT*APTT+1224.*APTT+495.)+n/23100.*		!For temperature
     *      (3636.*APTT*APTT+6380.*APTT+2805.)					!For temperature
	  AUX5=UNU*UNU*AUX5							!For temperature
          AUX6=UNU*(NFLOW+1.)/2./(2.-NFLOW)/72./(5./9.)**n			!For temperature
          AUX7=BR(IBR)*UNU**3*(280.*(162./35.)**n*APTT*APTT+504.*(110./		!For temperature
     *      21.)**n*APTT+225.*(88./15.)**n)/270./(385./54.)**NFLOW		!For temperature
          DO II=1,npoints+1							!For temperature
	    AUX3(II)=(r(II)**6-9.*(5./3.)**n*r(II)*r(II)+8.*(7./4.)**n)*	!For temperature
     *        2.**(NFLOW+1.)*APTT+9.*(5./9.)**n*(r(II)**4-4.*1.5**n*		!For temperature
     *        r(II)*r(II)+3.*(5./3.)**n)					!For temperature
	    AUX3(II)=AUX5-AUX6*AUX3(II)
	    AUX8(II)=(3.+NFLOW)*BR(IBR)*UNU*2.*(2.-NFLOW)*AUX3(II)-AUX7-
     *        BR(IBR)*UNU*UNU*(2.**(NFLOW+2.)*APTT*(r(II)**6-1.)+(5.+4.*
     *        NFLOW)*(r(II)**4-1.))*3./(20.+7.*NFLOW)
	  END DO
          DO 60 I=1,NXS
	   SUMNUM=0.									!For Nusselt
           AUX4(I)=(NFLOW+1.)*x(I)*(1./2./(2.-NFLOW)+(3.+NFLOW)*BR(IBR)*
     *       UNU)
           DO II=1,npoints+1							!for temperature
	     SUMTET(II)=0.							!for temperature
	   END DO								!for temperature
	   DO 65 k=1,NEIGEN
             AAA=2.*EXP(-EV(k)*EV(k)*x(I))/EV(k)/ywall(3,k)*			!For Nusselt and temperature
     *        (ywall(2,k)/2./(2.-NFLOW)+(3.+NFLOW)*(3.+NFLOW)*BR(IBR)*		!For Nusselt and temperature
     *        AINTEGR(k))							!For Nusselt and temperature
     	     SUMNUM=SUMNUM+AAA								!For Nusselt
             DO II=1,npoints+1
               SUMTET(II)=SUMTET(II)+AAA*y2(k,II)/ywall(2,k)			!for temperature
	     END DO
 65        CONTINUE
            ANUSSEL(I)=1./(AUX1+AUX2+SUMNUM)	!Nusselt final for qw=cte
	    THETAM(I)=1/ANUSSEL(I)		!Thetam
            DO II=1,npoints+1
              TETA(II,I)=AUX4(I)+AUX3(II)+AUX8(II)+SUMTET(II)
	    END DO
 60       CONTINUE
	
	
	END IF
c   End of all calculations

c   Output of final results: Nusselt numbers and temperature profiles
	WRITE(16,*)'Brinkman =',BR(IBR)
       WRITE(16,*)'I         xprime             Nusselt          THETAM'
        DO I=1,NXS
	 WRITE(16,*)I,xprime(I),ANUSSEL(I),THETAM(I)
	END DO
        WRITE(16,*)


	WRITE(17,*)'Brinkman =',BR(IBR)
        DO I=1,NXS
	 WRITE(17,*)'I= ',I,'  xprime=',xprime(I),'Nu(x)=',ANUSSEL(I)
	 WRITE(17,*)
         WRITE(17,*)'II         r*               theta(r)'
	 DO II=1,npoints+1
	   WRITE(17,*)II,r(II),TETA(II,I)
	 END DO
	END DO

c   End of output of final results

 130     CONTINUE	

	CLOSE(16)
	CLOSE(17)


c   for control
c        DO k=1,NEIGEN
c         WRITE(*,*)'EV(',k,')= ',EV(k),'I1  =',AINTEGR(k)
c	END DO
c	pause

c        DO k=1,NEIGEN
c	  DO J=1,nfun
c	    WRITE(*,50)npoints+1,x(npoints+1),ywall(J,k),ywallpr(J,k)
c	  END DO
c	END DO
c	pause
	
c	DO k=1,NEIGEN
c	  DO I=1,npoints+1
c	    WRITE(*,50)I,x(I),y2(k,I)
c	  END DO
c	END DO
c	pause

c   end of control

	STOP
	
 50     FORMAT(1X,I4,3(3X,F15.11))
	
	END

